osgShadow::MinimalCullBoundsShadowMap::ViewData Struct Reference

`#include <MinimalCullBoundsShadowMap>`

Inheritance diagram for osgShadow::MinimalCullBoundsShadowMap::ViewData:

## Public Types

typedef std::vector< osgUtil::RenderLeaf * > | RenderLeafList
Public Types inherited from osgShadow::DebugShadowMap::ViewData
typedef std::map< std::string, PolytopeGeometry > | PolytopeGeometryMap

## Public Member Functions

virtual void | init (ThisClass *st, osgUtil::CullVisitor *cv)
virtual void | cullShadowReceivingScene ()
virtual void | aimShadowCastingCamera (const osg::Light *light, const osg::Vec4 &worldLightPos, const osg::Vec3 &worldLightDir, const osg::Vec3 &worldLightUp=osg::Vec3(0, 1, 0))
Public Member Functions inherited from osgShadow::MinimalShadowMap::ViewData
virtual void | init (ThisClass *st, osgUtil::CullVisitor *cv)
virtual osg::BoundingBox | computeShadowReceivingCoarseBounds ()
virtual void | aimShadowCastingCamera (const osg::BoundingSphere &bounds, const osg::Light *light, const osg::Vec4 &worldLightPos, const osg::Vec3 &worldLightDir, const osg::Vec3 &worldLightUp=osg::Vec3(0, 1, 0))
virtual void | frameShadowCastingCamera (const osg::Camera *cameraMain, osg::Camera *cameraShadow, int pass=1)
void | cutScenePolytope (const osg::Matrix &matrix, const osg::Matrix &inverse, const osg::BoundingBox &bb=osg::BoundingBox(-1,-1,-1, 1, 1, 1))
osg::BoundingBox | computeScenePolytopeBounds ()
osg::BoundingBox | computeScenePolytopeBounds (const osg::Matrix &m)
Public Member Functions inherited from osgShadow::StandardShadowMap::ViewData
virtual void | init (ThisClass *st, osgUtil::CullVisitor *cv)
virtual void | cull ()
virtual void | cullShadowCastingScene ()
virtual void | addShadowReceivingTexGen ()
virtual const osg::Light * | selectLight (osg::Vec4 &viewLightPos, osg::Vec3 &viewLightDir)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osgShadow::DebugShadowMap::ViewData
bool | getDebugDraw ()
std::string * | getDebugDump ()
virtual void | init (ThisClass *st, osgUtil::CullVisitor *cv)
virtual void | createDebugHUD (void)
virtual void | cullDebugGeometry ()
virtual void | updateDebugGeometry (const osg::Camera *screenCam, const osg::Camera *shadowCam)
void | setDebugPolytope (const char *name, const ConvexPolyhedron &polytope= *(ConvexPolyhedron *)(NULL), osg::Vec4 colorOutline=osg::Vec4(0, 0, 0, 0), osg::Vec4 colorInside=osg::Vec4(0, 0, 0, 0))
bool | DebugBoundingBox (const osg::BoundingBox &bb, const char *name="")
bool | DebugPolytope (const osg::Polytope &p, const char *name="")
bool | DebugMatrix (const osg::Matrix &m, const char *name="")
void | dump (const std::string &filename)
Public Member Functions inherited from osgShadow::ViewDependentShadowTechnique::ViewData
virtual const char * | className () const
virtual void | init (ViewDependentShadowTechnique *st, osgUtil::CullVisitor *cv)
virtual void | dirty (bool flag)
| ViewData ()
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static unsigned | RemoveOldRenderLeaves (RenderLeafList &rllNew, RenderLeafList &rllOld)
static unsigned | RemoveIgnoredRenderLeaves (RenderLeafList &rll)
static osg::BoundingBox | ComputeRenderLeavesBounds (RenderLeafList &rll, osg::Matrix &projectionToWorld)
static osg::BoundingBox | ComputeRenderLeavesBounds (RenderLeafList &rll, osg::Matrix &projectionToWorld, osg::Polytope &polytope)
static void | GetRenderLeaves (osgUtil::RenderBin *rb, RenderLeafList &rll)
Static Public Member Functions inherited from osgShadow::MinimalShadowMap::ViewData
static void | trimProjection (osg::Matrixd &projection, osg::BoundingBox subrange, unsigned int trimMask=(1|2|4|8|16|32))
static void | clampProjection (osg::Matrixd &projection, float n=0, float f=FLT_MAX)
static void | extendProjection (osg::Matrixd &projection, osg::Viewport *viewport, const osg::Vec2 &margin)
Static Public Member Functions inherited from osgShadow::DebugShadowMap::ViewData
static osg::Vec3d | computeShadowTexelToPixelError (const osg::Matrix &mvpwView, const osg::Matrix &mvpwShadow, const osg::Vec3d &vWorld, const osg::Vec3d &vDelta=osg::Vec3d(0.01, 0.01, 0.01))
static void | displayShadowTexelToPixelErrors (const osg::Camera *viewCam, const osg::Camera *shadowCam, const ConvexPolyhedron *hull)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Additional Inherited Members

Public Attributes inherited from osgShadow::MinimalShadowMap::ViewData
osg::Matrix * | _modellingSpaceToWorldPtr
float * | _maxFarPlanePtr
float * | _minLightMarginPtr
int | _frameShadowCastingCameraPasses
ConvexPolyhedron | _sceneReceivingShadowPolytope
std::vector< osg::Vec3d > | _sceneReceivingShadowPolytopePoints
osg::Matrixd | _clampedProjection
Public Attributes inherited from osgShadow::StandardShadowMap::ViewData
osg::ref_ptr< osg::Light > * | _lightPtr
unsigned int * | _baseTextureUnitPtr
unsigned int * | _shadowTextureUnitPtr
osg::ref_ptr< osg::TexGen > | _texgen
osg::ref_ptr< osg::StateSet > | _stateset
Public Attributes inherited from osgShadow::DebugShadowMap::ViewData
osg::ref_ptr< osg::Texture > | _texture
osg::ref_ptr< osg::Camera > | _camera
osg::Matrixd | _viewProjection
osg::observer_ptr< osg::Camera > | _viewCamera
osg::ref_ptr< osg::Shader > | _depthColorFragmentShader
osg::Vec2s | _hudSize
osg::Vec2s | _hudOrigin
osg::Vec2s | _viewportSize
osg::Vec2s | _viewportOrigin
osg::Vec2s | _orthoSize
osg::Vec2s | _orthoOrigin
bool * | _doDebugDrawPtr
std::string * | _debugDumpPtr
PolytopeGeometryMap | _polytopeGeometryMap
osg::ref_ptr< osg::Geode > | _geode [2]
osg::ref_ptr< osg::MatrixTransform > | _transform [2]
std::map< std::string, osg::Matrix > | _matrixMap
std::map< std::string, osg::Polytope > | _polytopeMap
std::map< std::string, osg::BoundingBox > | _boundingBoxMap
osg::ref_ptr< osg::Camera > | _cameraDebugHUD
Public Attributes inherited from osgShadow::ViewDependentShadowTechnique::ViewData
OpenThreads::Mutex | _mutex
bool | _dirty
osg::observer_ptr< osgUtil::CullVisitor > | _cv
osg::observer_ptr< ViewDependentShadowTechnique > | _st
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Typedef Documentation

## RenderLeafList

typedef std::vector< osgUtil::RenderLeaf* > osgShadow::MinimalCullBoundsShadowMap::ViewData::RenderLeafList

## Member Function Documentation

## aimShadowCastingCamera()

virtual void osgShadow::MinimalCullBoundsShadowMap::ViewData::aimShadowCastingCamera | ( | const osg::Light * | light,
|  | const osg::Vec4 & | worldLightPos,
|  | const osg::Vec3 & | worldLightDir,
|  | const osg::Vec3 & | worldLightUp = osg::Vec3(0, 1, 0) )

virtual

Reimplemented from osgShadow::MinimalShadowMap::ViewData.

## ComputeRenderLeavesBounds() [1/2]

osg::BoundingBox osgShadow::MinimalCullBoundsShadowMap::ViewData::ComputeRenderLeavesBounds | ( | RenderLeafList & | rll,
|  | osg::Matrix & | projectionToWorld )

static

## ComputeRenderLeavesBounds() [2/2]

osg::BoundingBox osgShadow::MinimalCullBoundsShadowMap::ViewData::ComputeRenderLeavesBounds | ( | RenderLeafList & | rll,
|  | osg::Matrix & | projectionToWorld,
|  | osg::Polytope & | polytope )

static

## cullShadowReceivingScene()

virtual void osgShadow::MinimalCullBoundsShadowMap::ViewData::cullShadowReceivingScene | ( |  | ) |

virtual

Reimplemented from osgShadow::MinimalShadowMap::ViewData.

## GetRenderLeaves()

void osgShadow::MinimalCullBoundsShadowMap::ViewData::GetRenderLeaves | ( | osgUtil::RenderBin * | rb,
|  | RenderLeafList & | rll )

static

## init()

virtual void osgShadow::MinimalCullBoundsShadowMap::ViewData::init | ( | ThisClass * | st,
|  | osgUtil::CullVisitor * | cv )

virtual

## RemoveIgnoredRenderLeaves()

unsigned osgShadow::MinimalCullBoundsShadowMap::ViewData::RemoveIgnoredRenderLeaves | ( | RenderLeafList & | rll | ) |

static

## RemoveOldRenderLeaves()

unsigned osgShadow::MinimalCullBoundsShadowMap::ViewData::RemoveOldRenderLeaves | ( | RenderLeafList & | rllNew,
|  | RenderLeafList & | rllOld )

static

The documentation for this struct was generated from the following file:

- MinimalCullBoundsShadowMap